package com.yingpaipay.setting.service.impl;

import org.dromara.common.core.constant.CacheNames;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.redis.utils.CacheUtils;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.CachePut;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Service;
import com.yingpaipay.setting.domain.bo.CarouselSettingBo;
import com.yingpaipay.setting.domain.vo.CarouselSettingVo;
import com.yingpaipay.setting.domain.CarouselSetting;
import com.yingpaipay.setting.mapper.CarouselSettingMapper;
import com.yingpaipay.setting.service.ICarouselSettingService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 轮播图设置Service业务层处理
 *
 * @author Huanyi
 * @date 2025-12-29
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class CarouselSettingServiceImpl implements ICarouselSettingService {

    private final CarouselSettingMapper baseMapper;

    /**
     * 查询轮播图设置
     *
     * @param id 主键
     * @return 轮播图设置
     */
    @Cacheable(cacheNames = CacheNames.CAROUSEL_SETTING, key = "#id")
    @Override
    public CarouselSettingVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询轮播图设置列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 轮播图设置分页列表
     */
    @Override
    public TableDataInfo<CarouselSettingVo> queryPageList(CarouselSettingBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<CarouselSetting> lqw = buildQueryWrapper(bo);
        Page<CarouselSettingVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的轮播图设置列表
     *
     * @param bo 查询条件
     * @return 轮播图设置列表
     */
    @Cacheable(cacheNames = CacheNames.CAROUSEL_SETTING)
    @Override
    public List<CarouselSettingVo> queryList(CarouselSettingBo bo) {
        LambdaQueryWrapper<CarouselSetting> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<CarouselSetting> buildQueryWrapper(CarouselSettingBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<CarouselSetting> lqw = Wrappers.lambdaQuery();
        // 需要按排序从小到大
        lqw.orderByAsc(CarouselSetting::getSort);
        return lqw;
    }

    /**
     * 新增轮播图设置
     *
     * @param bo 轮播图设置
     * @return 是否新增成功
     */
    @CachePut(cacheNames = CacheNames.CAROUSEL_SETTING, key = "#bo.id")
    @Override
    public Boolean insertByBo(CarouselSettingBo bo) {
        CarouselSetting add = MapstructUtils.convert(bo, CarouselSetting.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改轮播图设置
     *
     * @param bo 轮播图设置
     * @return 是否修改成功
     */
    @CachePut(cacheNames = CacheNames.CAROUSEL_SETTING, key = "#bo.id")
    @Override
    public Boolean updateByBo(CarouselSettingBo bo) {
        CarouselSetting update = MapstructUtils.convert(bo, CarouselSetting.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(CarouselSetting entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除轮播图设置信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        ids.forEach(id -> CacheUtils.evict(CacheNames.CAROUSEL_SETTING, id));
        return baseMapper.deleteByIds(ids) > 0;
    }
}
